#include "define.h"  
*// ============================================================================================ //
*//    
*// ============================================================================================ //
define class es_head as header

    Alignment = 2
   
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//      
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function click
       this.parent.SetOrder()
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
  
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function SetSortColor
      this.BackColor = 8404992
      this.ForeColor = 16777215
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function UndoSortColor
      this.BackColor = 12632256
      this.ForeColor = 0
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //

    
enddefine
*// ============================================================================================ //




*// ============================================================================================ //
*//  "" 
*// ============================================================================================ //
define class es_ext_head as container
  
    *// ------------------------------------------------------------ //
    width = 1
*    backstyle = 0
    *// ------------------------------------------------------------ //
    add object storey as es_array_one  &&//    
    storeyheight = 16
    labelheight = 16
    column   = 0          &&//  
    fontbold = .F.        &&//  
    *// ------------------------------------------------------------ //
        
            
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function init
    parameters viewheader
    local i, cLabel, oLabel
       if this.parent.l3d
          this.specialeffect = 0
       endif
       this.column = viewheader.column
       this.height = (viewheader.nStoreyVirtual * this.labelheight) + 1
       this.storeyheight = this.height / viewheader.count
       for i = 1 to viewheader.count
           this.addobject( "label" + itoc(i), "es_label" )
           cLabel = "oLabel = this.label" + itoc(i)
           oLabel = .F.
           seterrorempty()
           &cLabel
           seterrorcomm()
           if object( oLabel )
              this.storey.add(oLabel)
              oLabel.caption = viewheader.list[i]
              oLabel.height  = this.labelheight
              oLabel.visible = .T.
              oLabel.backstyle = 0
           endif
       endfor
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//  
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function arrange
    local i, nTop
       nTop = int((this.storeyheight - this.labelheight)/ 2 )
       for i = 1 to this.storey.count
           this.storey.list[i].fontbold = this.fontbold
           this.storey.list[i].top =  nTop + (i - 1) * this.storeyheight
           this.storey.list[i].left = (this.width - this.storey.list[i].width) / 2
       endfor
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    *//      
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function click
       &&// this.parent.grid.SetOrder( this.column )
       this.parent.treat( CONT_HEADER_CLICK, this.column )
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function SetSortColor
    local i
      this.BackColor = 8404992
      for i = 1 to this.storey.count
        this.storey.list[i].forecolor = 16777215
      endfor
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
    function UndoSortColor
    local i
      this.BackColor = 12632256
      for i = 1 to this.storey.count
        this.storey.list[i].forecolor = 0
      endfor
    endfun
    *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
      
    
  
enddefine
*// ============================================================================================ //
*//    
*// ============================================================================================ //
define class es_head_index as container
   column = 0
   fontbold = .F.
   add object label as es_label with backstyle = 0
   *// ------------------------------------------------------------ //
   function init
   parameters cCaption
      if this.parent.l3d
         this.specialeffect = 0
      endif
      this.label.caption = cCaption
      this.label.visible = .T.
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function arrange
     this.label.fontbold = this.fontbold
     this.label.left = (this.width - this.label.width) / 2
     this.label.top = 1
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
enddefine
*// ============================================================================================ //
