#include "define.h"
*// ============================================================================================ //
*//   
*// ============================================================================================ //
define class es_cont_headers as es_container
   *// ------------------------------------------------------------ //
   borderwidth = 0
   l3D = .T.
   storeyheight = 16                     &&//  
   cHeadClass = "es_ext_head"            &&//   
   declare topheads(1)                   &&//    
   topcount = 0                          &&//    
   nLightHead = 0                        &&//  
   *// ------------------------------------------------------------ //


   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//   ,
   *//          viewstruct,
   *//             
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function load
   parameters ViewStruct, lIndex, l3D
   local nCol, nHead, i,;   &&//   
         nIndex, ;          &&//   () 
         oHead,;            &&//     
         cHeadIndex, cHeadClass,;
         nColHeight,;       &&//   
         nColLeft           &&//     
      if !object( viewstruct )
         return .F.
      endif
      this.clear()
      this.l3D = l3D
      *// -------------------------
      this.height = viewstruct.nMaxStorey * this.storeyheight + iif( lIndex, this.storeyheight, 0 )
      nColLeft = 0
      for nCol = 1 to viewstruct.count
          nColHeight = 0
          for nHead = 1 to viewstruct.list[nCol].count
              if viewstruct.list[nCol].index != viewstruct.list[nCol].list[nHead].column
                 nColHeight = nColHeight + viewstruct.list[nCol].list[nHead].height - 1
                 loop
              endif
              nIndex = this.controlcount + 1
              cHeadIndex = itoc( nIndex )
              this.addobject( "header" + cHeadIndex, iif( len( viewstruct.list[nCol].cClassEHead ) > 0,;
                   viewstruct.list[nCol].cClassEHead, this.cHeadClass ), viewstruct.list[nCol].list[nHead] )
              oHead = .F.
              if this.controlcount < nIndex
                 loop
              endif
              oHead = this.controls[nIndex]
              *// -------------------------
              oHead.visible = .T.
              oHead.width = 1
              for i = 0 to viewstruct.list[nCol].list[nHead].nWidthCol - 1
                  oHead.width = oHead.width + viewstruct.list[nCol+i].nWidthPix + 1
              endfor
              oHead.top = nColHeight
              oHead.left = nColLeft
              nColHeight = nColHeight + oHead.height - 1
              viewstruct.list[nCol].list[nHead].height = oHead.height
              &&//   
              do case
                 case nHead == 1
                      if viewstruct.list[nCol].lBoldTop
                         oHead.fontbold = .T.
                      endif
                 case nHead == viewstruct.list[nCol].count
                      if viewstruct.list[nCol].lBoldBott
                         oHead.fontbold = .T.
                      endif
                 case viewstruct.list[nCol].lBoldOther
                      oHead.fontbold = .T.
              endcase
              oHead.arrange()
          endfor
          *// -------------------------
          *//   
          if object( oHead )
             this.AddTop( oHead )
          endif
          *// -------------------------
          *//  
          if lIndex
             nIndex = this.controlcount + 1
             cHeadIndex = itoc( nIndex )
             this.addobject( "header" + cHeadIndex, "es_head_index", viewstruct.list[nCol].cGround )
             oHead = .F.
             if this.controlcount < nIndex
                loop
             endif
             oHead = this.controls[nIndex]
             &&//   
             if nHead == 1
                this.AddTop( oHead )
             endif
             oHead.visible = .T.
             oHead.width = viewstruct.list[nCol].nWidthPix + 2
             oHead.height = this.storeyheight + 1
             oHead.top = nColHeight
             oHead.left = nColLeft
             oHead.fontbold = viewstruct.list[nCol].lBoldIndex
             oHead.column = nCol
             oHead.arrange()
          endif
          *// -------------------------
          *//     
          nColLeft = nColLeft + viewstruct.list[nCol].nWidthPix + 1
      endfor
      this.width = nColLeft
      *// -------------------------
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//          
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   protected function AddTop
   parameters oHead
     this.topcount = this.topcount + 1
     declare this.topheads(this.topcount)
     this.topheads[this.topcount] = oHead
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//    
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function clear
   local i
     for i = this.controlcount to 1 step -1
         this.removeobject( this.controls[i].name )
     endfor
     this.topcount = 0
     declare this.topheads(1)
     this.topheads[1] = .F.
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//   
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function treat
   parameters nEvent, xParam
     do case
        case nEvent == CONT_HEADER_CLICK
             return this.parent.treat( nEvent, xParam )
     endcase
     retur .t.
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   *//   
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //
   function HighLight
   parameters nColumn
     if this.topcount <= 0 or !numeric(nColumn) or nColumn > this.topcount
        return .F.
     endif
     if this.nLightHead > 0
        this.topheads[this.nLightHead].UndoSortColor()
     endif
     this.nLightHead = nColumn
     this.topheads[nColumn].SetSortColor()
     return .T.
   endfun
   *// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ //

enddefine
*// ============================================================================================ //